
%donald

viewport PAD

openshape pad

within pad {

point interpoint0,currentpoint
int cpx,cpy

interpoint0 = {0,0}

}

%scout

window pad,text_display;
display scr;
point topleftpad, bottomrightpad;
integer input;
string background_color,displaytext;

topleftpad = {200,20};
bottomrightpad = {400,220};
background_color="white";
displaytext="Click and drag on the pad to draw.";

pad = {
	box:[topleftpad, bottomrightpad],
	pict: "PAD",
	type: DONALD,
	xmin: 0,
	xmax:200,
	ymin: 0,
	ymax: 200,
	border: 1,
	sensitive: ON + MOTION,                      
	bgcolor:background_color
	};

text_display = {
	frame: ([{200,250},{400,290}]),
	type: TEXT,
	border: 1,
	sensitive: OFF,
	string: displaytext,
    bgcolor:background_color
	};

scr = <pad/text_display >; 
screen = scr;

%eden

clickcheck = false;

proc pad_click : pad_mouse
{
    clickcheck is pad_mouse[2]==4;
}

counter=1;

proc pad_move : pad_mousePos
{
    if(clickcheck)
    {
        execute("%donald
        openshape pad
        within pad{
        currentpoint = interpoint"//str((counter-1))//"
        }");

        x = (pad_mousePos[1]) - (_pad_currentpoint[2]);
        y = (pad_mousePos[2]) - (_pad_currentpoint[3]);
        add_new_line_free(x,y);
    }
}


/* The procedure for adding a new point and line */

proc add_new_line_free
{
    para x,y;

    execute("%donald
    openshape pad
    within pad{
    point interpoint"//str(counter)//"
    interpoint"//str(counter)//" = interpoint"//str(counter-1)//"+ {"//str(x)//","//str(y)//"}
    line line"//str(counter)//"
    }");

    if(counter > 1)
    {
        execute("%donald
        openshape pad
        within pad{   
        line"//str(counter)//" = [interpoint"//str(counter)//",interpoint"//str(counter-1)//"]
        }");
    }

    counter = counter + 1;
}
